diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index ec3d8fba8..828a9b86e 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1065,7 +1112,6 @@ class WorkbenchGenerator {
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_PALM).create(String.format(format, "palm", "yellow"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.YELLOW.blockMeta));
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_THORN).create(String.format(format, "thorn", "red"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.RED.blockMeta));
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_PINE).create(String.format(format, "pine", "brown"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.BROWN.blockMeta));
-        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_PETRIFIED).create(String.format(format, "petrified", "gray"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 2, DyeColor.SILVER.blockMeta));
     }
 
     private static void generatePolishedStones() {
@@ -1094,9 +1140,11 @@ class WorkbenchGenerator {
                 " X "
             ).addInput('#', Items.DUST_REDSTONE);
 
-        info.addInput('X', "minecraft:planks").create("rotary_calendar", Items.TOOL_CALENDAR.getDefaultStack());
-        info.addInput('X', Items.INGOT_IRON).create("compass", Items.TOOL_COMPASS.getDefaultStack());
-        info.addInput('X', Items.INGOT_GOLD).create("clock", Items.TOOL_CLOCK.getDefaultStack());
+        RecipeBuilder.consolidationGroup("info_tools", () -> {
+            info.addInput('X', "minecraft:planks").create("rotary_calendar", Items.TOOL_CALENDAR.getDefaultStack());
+            info.addInput('X', Items.INGOT_IRON).create("compass", Items.TOOL_COMPASS.getDefaultStack());
+            info.addInput('X', Items.INGOT_GOLD).create("clock", Items.TOOL_CLOCK.getDefaultStack());
+        });
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1129,6 +1177,15 @@ class WorkbenchGenerator {
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.BROWN.itemMeta))
             .create("cookie", new ItemStack(Items.FOOD_COOKIE, 16));
 
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "GGG",
+                "GAG",
+                "GGG")
+            .addInput('G', Items.INGOT_GOLD)
+            .addInput('A', Items.FOOD_APPLE)
+            .create("apple_gold", Items.FOOD_APPLE_GOLD.getDefaultStack());
+
         RecipeBuilderShaped cakeBase = RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "AAA",
@@ -1393,14 +1450,6 @@ class WorkbenchGenerator {
             .addInput('I', "minecraft:stones")
             .create("redstone_timer", new ItemStack(Items.TIMER, 1));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "X",
-                "#")
-            .addInput('X', Blocks.PUMPKIN_CARVED_IDLE)
-            .addInput('#', Blocks.TORCH_REDSTONE_ACTIVE)
-            .create("carved_pumpkin_to_redstone_jack_o_lantern", Blocks.PUMPKIN_REDSTONE.getDefaultStack());
-
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "X X",
@@ -1442,9 +1491,9 @@ class WorkbenchGenerator {
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
-                "#Q#",
-                "#C#",
-                "#Q#"
+                "###",
+                "QCQ",
+                "###"
             )
             .addInput('#', Blocks.NETHERRACK)
             .addInput('Q', Items.QUARTZ)
@@ -1453,11 +1502,11 @@ class WorkbenchGenerator {
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
                 .setShape(
-                        "XOX",
-                        "ORO",
-                        "XOX")
-                .addInput('R', Items.DUST_REDSTONE)
-                .addInput('O', Items.RUBYGLASS)
+                        "XRX",
+                        "DDD",
+                        "XRX")
+                .addInput('D', Items.DUST_REDSTONE)
+                .addInput('R', Items.RUBYGLASS)
                 .addInput('X', Blocks.NETHERRACK)
                 .create("conduit", new ItemStack(Blocks.CONDUIT, 1));
 
@@ -1474,19 +1523,23 @@ class WorkbenchGenerator {
     }
 
     private static void generateScrapRecipes() {
-        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_boots",        new RecipeEntryScrap(Items.ARMOR_BOOTS_CHAINMAIL,       Items.CHAINLINK, 4));
-        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_leggings",     new RecipeEntryScrap(Items.ARMOR_LEGGINGS_CHAINMAIL,    Items.CHAINLINK, 4));
-        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_chestplate",   new RecipeEntryScrap(Items.ARMOR_CHESTPLATE_CHAINMAIL,  Items.CHAINLINK, 4));
-        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_helmet",       new RecipeEntryScrap(Items.ARMOR_HELMET_CHAINMAIL,      Items.CHAINLINK, 4));
-        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_wolf",         new RecipeEntryScrap(Items.ARMOR_WOLF_CHAINMAIL,        Items.CHAINLINK, 4));
+        RecipeBuilder.consolidationGroup("scrap", () -> {
+            Registries.RECIPES.WORKBENCH.register("scrap_chainmail_boots",        new RecipeEntryScrap(Items.ARMOR_BOOTS_CHAINMAIL,       Items.CHAINLINK, 4));
+            Registries.RECIPES.WORKBENCH.register("scrap_chainmail_leggings",     new RecipeEntryScrap(Items.ARMOR_LEGGINGS_CHAINMAIL,    Items.CHAINLINK, 4));
+            Registries.RECIPES.WORKBENCH.register("scrap_chainmail_chestplate",   new RecipeEntryScrap(Items.ARMOR_CHESTPLATE_CHAINMAIL,  Items.CHAINLINK, 4));
+            Registries.RECIPES.WORKBENCH.register("scrap_chainmail_helmet",       new RecipeEntryScrap(Items.ARMOR_HELMET_CHAINMAIL,      Items.CHAINLINK, 4));
+            Registries.RECIPES.WORKBENCH.register("scrap_chainmail_wolf",         new RecipeEntryScrap(Items.ARMOR_WOLF_CHAINMAIL,        Items.CHAINLINK, 4));
+        });
     }
 
     private static void generateRepairableRecipes() {
-         Registries.RECIPES.WORKBENCH.register("repair_chainmail_boots",       new RecipeEntryRepairable(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack(),        new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-         Registries.RECIPES.WORKBENCH.register("repair_chainmail_leggings",    new RecipeEntryRepairable(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack(),     new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-         Registries.RECIPES.WORKBENCH.register("repair_chainmail_chestplate",  new RecipeEntryRepairable(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack(),   new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-         Registries.RECIPES.WORKBENCH.register("repair_chainmail_helmet",      new RecipeEntryRepairable(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack(),       new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-         Registries.RECIPES.WORKBENCH.register("repair_chainmail_wolf",        new RecipeEntryRepairable(Items.ARMOR_WOLF_CHAINMAIL.getDefaultStack(),         new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+        RecipeBuilder.consolidationGroup("repair", () -> {
+            Registries.RECIPES.WORKBENCH.register("repair_chainmail_boots",       new RecipeEntryRepairable(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack(),        new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+            Registries.RECIPES.WORKBENCH.register("repair_chainmail_leggings",    new RecipeEntryRepairable(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack(),     new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+            Registries.RECIPES.WORKBENCH.register("repair_chainmail_chestplate",  new RecipeEntryRepairable(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack(),   new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+            Registries.RECIPES.WORKBENCH.register("repair_chainmail_helmet",      new RecipeEntryRepairable(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack(),       new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+            Registries.RECIPES.WORKBENCH.register("repair_chainmail_wolf",        new RecipeEntryRepairable(Items.ARMOR_WOLF_CHAINMAIL.getDefaultStack(),         new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+        });
     }
 
     private static void generateToolRecipes() {
@@ -1494,10 +1547,22 @@ class WorkbenchGenerator {
     }
 
     private static void generateStatueRecipes() {
-        final String[] statueNames = new String[]{"stone", "basalt", "limestone", "granite", "marble", "slate", "permafrost", "netherrack", "gloomstone"};
-        final Item[] statueItems = new Item[]{Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE, Items.STATUE_GRANITE, Items.STATUE_MARBLE, Items.STATUE_SLATE, Items.STATUE_PERMAFROST, Items.STATUE_NETHERRACK, Items.STATUE_GLOOMSTONE};
-        final Block<?>[] statueBodyBlocks = new Block[]{Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.MARBLE, Blocks.SLATE, Blocks.PERMAFROST, Blocks.NETHERRACK, Blocks.GLOOMSTONE};
-        final Block<?>[] statueBaseBlocks = new Block[]{Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED, Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE, Blocks.SLAB_SLATE_POLISHED, Blocks.SLAB_PERMAFROST_POLISHED, Blocks.SLAB_NETHERRACK_POLISHED, Blocks.SLAB_GLOOMSTONE_POLISHED};
+        final String[] statueNames = new String[]{
+                "stone", "basalt", "limestone",
+                "granite", "marble", "slate",
+                "permafrost", "netherrack", "gloomstone"};
+        final Item[] statueItems = new Item[]{
+                Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE,
+                Items.STATUE_GRANITE, Items.STATUE_MARBLE, Items.STATUE_SLATE,
+                Items.STATUE_PERMAFROST, Items.STATUE_NETHERRACK, Items.STATUE_GLOOMSTONE};
+        final Block<?>[] statueBodyBlocks = new Block[]{
+                Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE,
+                Blocks.GRANITE, Blocks.MARBLE, Blocks.SLATE,
+                Blocks.PERMAFROST, Blocks.NETHERRACK, Blocks.GLOOMSTONE};
+        final Block<?>[] statueBaseBlocks = new Block[]{
+                Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED,
+                Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE, Blocks.SLAB_SLATE_POLISHED,
+                Blocks.SLAB_PERMAFROST_POLISHED, Blocks.SLAB_NETHERRACK_POLISHED, Blocks.SLAB_GLOOMSTONE_POLISHED};
 
         for (int i = 0; i < statueItems.length; i++) {
             RecipeBuilder.Shaped(CORE_NAMESPACE)
@@ -1546,16 +1611,13 @@ class WorkbenchGenerator {
 
     private static void generateMiscNewRecipes() {
         // Brimstone Formatting
-        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Blocks.BRIMSAND).create("brimstone", new ItemStack(Blocks.BRIMSTONE, 2));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.BRIMSTONE).create("brimstone_slab", new ItemStack(Blocks.SLAB_BRIMSTONE, 6));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("S  ", "SS ", "SSS").addInput('S', Blocks.BRIMSTONE).create("brimstone_stairs", new ItemStack(Blocks.STAIRS_BRIMSTONE, 6));
-        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Blocks.BRIMSTONE).create("brimstone_bricks", new ItemStack(Blocks.BRICK_BRIMSTONE, 4));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.BRICK_BRIMSTONE).create("brick_brimstone_slab", new ItemStack(Blocks.SLAB_BRICK_BRIMSTONE, 6));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("S  ", "SS ", "SSS").addInput('S', Blocks.BRICK_BRIMSTONE).create("brick_brimstone_stairs", new ItemStack(Blocks.STAIRS_BRICK_BRIMSTONE, 6));
 
         // Misc additions
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SSS").addInput('S', Blocks.SLATE_POLISHED).create("polished_slate_slab", new ItemStack(Blocks.SLAB_SLATE_POLISHED, 6));
-        RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("PO", "OP").addInput('P', Items.AMMO_PEBBLE).addInput('O', Blocks.OBSIDIAN).create("pebbles_to_gloomstone", new ItemStack(Blocks.COBBLE_GLOOMSTONE, 2));
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.SULFUR).addInput(Items.PAPER).addInput(Items.AMMO_ARROW).addInput(Items.SULFUR).create("flaming_arrow", new ItemStack(Items.AMMO_ARROW_FLAMING, 1));
         RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("SS", "SS").addInput('S', Items.SULFUR).create("sulfur_block", new ItemStack(Blocks.SULFUR, 1));
 
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
index 3fcfa9d36..305581fd4 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
@@ -182,6 +182,18 @@ public final class RecipeBuilder {
         return new RecipeBuilderTrommel(modID);
     }
 
+    public static String currentConsolidationGroup = null;
+
+    public static void consolidationGroup(String name, Runnable recipes) {
+        String previous = currentConsolidationGroup;
+        currentConsolidationGroup = name;
+        try {
+            recipes.run();
+        } finally {
+            currentConsolidationGroup = previous;
+        }
+    }
+
     public static boolean isExporting = false;
 
     /**
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
index 1bafdf30a..f41c7013c 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
@@ -223,6 +223,8 @@ public class RecipeBuilderShaped extends RecipeBuilderBase{
         }
         RecipeGroup<RecipeEntryCrafting<?, ?>> group = ((RecipeGroup<RecipeEntryCrafting<?, ?>>) RecipeBuilder.getRecipeGroup(modID, "workbench", new RecipeSymbol(Blocks.WORKBENCH.getDefaultStack())));
         if (group.getItem(recipeID) != null) throw new IllegalArgumentException("RecipeID '" + recipeID + "' already exists!");
-        group.register(recipeID, new RecipeEntryCraftingShaped(width, height, recipe, outputStack, consumeContainer, allowMirrored));
+        RecipeEntryCraftingShaped entry = new RecipeEntryCraftingShaped(width, height, recipe, outputStack, consumeContainer, allowMirrored);
+        entry.consolidationGroup = RecipeBuilder.currentConsolidationGroup;
+        group.register(recipeID, entry);
     }
 }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
index f73b51f76..46ee1cf11 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
@@ -85,6 +85,8 @@ public class RecipeBuilderShapeless extends RecipeBuilderBase{
     public void create(String recipeID, ItemStack outputStack) {
         RecipeGroup<RecipeEntryCrafting<?, ?>> group = ((RecipeGroup<RecipeEntryCrafting<?, ?>>) RecipeBuilder.getRecipeGroup(modID, "workbench", new RecipeSymbol(Blocks.WORKBENCH.getDefaultStack())));
         if (group.getItem(recipeID) != null) throw new IllegalArgumentException("RecipeID '" + recipeID + "' already exists!");
-        group.register(recipeID, new RecipeEntryCraftingShapeless(symbolShapelessList, outputStack));
+        RecipeEntryCraftingShapeless entry = new RecipeEntryCraftingShapeless(symbolShapelessList, outputStack);
+        entry.consolidationGroup = RecipeBuilder.currentConsolidationGroup;
+        group.register(recipeID, entry);
     }
 }
